<?php
/*
# ------------------------------------------------------------------------
# JA Catpopup module for Joomla 1.5
# ------------------------------------------------------------------------
# Copyright (C) 2004-2010 JoomlArt.com. All Rights Reserved.
# @license - PHP files are GNU/GPL V2. CSS / JS are Copyrighted Commercial,
# bound by Proprietary License of JoomlArt. For details on licensing, 
# Please Read Terms of Use at http://www.joomlart.com/terms_of_use.html.
# Author: JoomlArt.com
# Websites:  http://www.joomlart.com -  http://www.joomlancers.com
# Redistribution, Modification or Re-licensing of this file in part of full, 
# is bound by the License applied. 
# ------------------------------------------------------------------------
*/

// no direct jacatpopup
defined('_JEXEC') or die('Restricted jacatpopup');

if(!defined('_JA_CATPOPUP_')){
	define ('_JA_CATPOPUP_', 1);
	
	require_once (JPATH_SITE . '/components/com_content/helpers/route.php');

	class modJaCatpopupHelper
	{

		function replaceImage( &$row, $align, $autoresize, $maxchars, $showimage, $width = 0, $height = 0 ) {
			global $database, $_MAMBOTS, $current_charset;
			$regex = "/\<img.+src\s*=\s*\"([^\"]*)\"[^\>]*\>/";
			preg_match ($regex, $row->introtext, $matches);
			$images = (count($matches)) ? $matches : array();
			if (count($images)) $image = $images[1];
		
			if ($image && $showimage) {
				if ($autoresize && function_exists('imagecreatetruecolor') 
					&& ($image1 = modJaCatpopupHelper::processImage ( $image, $width, $height ))) {
						$image = "<img src=\"".$image1."\" alt=\"{$row->title}\" align=\"$align\" />";
				} else {
					$width = $width?"width=\"$width\"":"";
					$height = $height?"height=\"$height\"":"";
					$image = "<img src=\"".$image."\" alt=\"{$row->title}\" $width $height align=\"$align\" />";
				}
			} else $image = '';

			$regex1 = "/\<img.*\/\>/";
			$row->introtext = preg_replace( $regex1, '', $row->introtext );
			$row->introtext = trim($row->introtext);

			$row->introtext1 = strip_tags($row->introtext);
			if ($maxchars && strlen ($row->introtext) > $maxchars) {
				$row->introtext1 = substr ($row->introtext1, 0, $maxchars) . "...";
			}
			// clean up globals
			return $image;
		}

		function processImage ( &$img, $width, $height ) {
			if(!$img) return;
			$img = str_replace(JURI::base(),'',$img);
			$img = rawurldecode($img);
			$imagesurl = (file_exists(JPATH_SITE .'/'.$img)) ? modJaCatpopupHelper::jaResize($img,$width,$height) :  '' ;
			return $imagesurl;
		}
		
		function jaResize($image,$max_width,$max_height){
			$path = JPATH_SITE;
			$sizeThumb = getimagesize(JPATH_SITE.'/'.$image);
			$width = $sizeThumb[0];
			$height = $sizeThumb[1];
			$x_ratio = $max_width / $width;
			$y_ratio = $max_height / $height;
			if (($width <= $max_width) && ($height <= $max_height) ) {
				$tn_width = $width;
				$tn_height = $height;
			} else if (($x_ratio * $height) < $max_height) {
				$tn_height = ceil($x_ratio * $height);
				$tn_width = $max_width;
			} else {
				$tn_width = ceil($y_ratio * $width);
				$tn_height = $max_height;
			}
			if(file_exists($path.'/images/resized/'.$image)){
				$smallImg = getimagesize(JPATH_SITE.'/images/resized/'.$image);
				if (($smallImg[0] <= $tn_width && $smallImg[1] == $tn_height) ||
					($smallImg[1] <= $tn_height && $smallImg[0] == $tn_width)) {
						return "images/resized/".$image;
				}
			}
			if(!file_exists($path.'/images/resized/') && !mkdir($path.'/images/resized/',0755)) return '';
			$folders = explode('/',$image);
			$tmppath = $path.'/images/resized/';
			for($i=0;$i < count($folders)-1; $i++){
				if(!file_exists($tmppath.$folders[$i]) && !mkdir($tmppath.$folders[$i],0755)) return '';
				$tmppath = $tmppath.$folders[$i].'/';
			}
			$resized = $path.'/images/resized/'.$image;
			// read image
			$ext = strtolower(substr(strrchr($image, '.'), 1)); // get the file extension
			switch ($ext) { 
				case 'jpg':     // jpg
					$src = imagecreatefromjpeg(JPATH_SITE.'/'.$image);
					break;
				case 'png':     // png
					$src = imagecreatefrompng(JPATH_SITE.'/'.$image);
					break;
				case 'gif':     // gif
					$src = imagecreatefromgif(JPATH_SITE.'/'.$image);
					break;
				default:
			}
			$dst = imagecreatetruecolor($tn_width,$tn_height);
			imageantialias ($dst, true);
			imagecopyresampled ($dst, $src, 0, 0, 0, 0, $tn_width, $tn_height, $width, $height);
			imagejpeg($dst, $resized, 90); // write the thumbnail to cache as well...
			return "images/resized/".$image;
		}

		function calModStyle ($cols) {
			$modules = array();
			switch ($cols) {
				case 0: return null;
				break;
				case 1: 
					$modules[0]['class'] = "";
					$modules[0]['width'] = "100%";
					$modules[0]['subwidth'] = "100%";
					break;
				case 2: 
					$modules[0]['class'] = "-left";
					$modules[0]['width'] = "49.9%";
					$modules[0]['subwidth'] = "95%";
					$modules[1]['class'] = "-right";
					$modules[1]['width'] = "49.9%";
					$modules[1]['subwidth'] = "95%";
					break;
				default: 

					$width1 = round(99.6/($cols-0.1), 2);
					$width2 = round((99.6 - $width1*($cols-2))/2, 2);

					for ($i=1; $i<$cols - 1; $i++){
						$modules[$i]['class'] = "-center";
						$modules[$i]['width'] = $width1."%";
						$modules[$i]['subwidth'] = "90%";
					}
					$modules[0]['class'] = "-left";
					$modules[0]['width'] = $width2."%";
					$modules[0]['subwidth'] = "95%";
					$modules[$cols - 1]['class'] = "-right";
					$modules[$cols - 1]['width'] = $width2."%";
					$modules[$cols - 1]['subwidth'] = "95%";
					break;
			}
			return $modules;
		}

		function unhtmlentities($string) 
		{
			$trans_tbl = array("&lt;" => "<", "&gt;" => ">", "&amp;" => "&");
			return strtr($string, $trans_tbl);
		}
		
		function getList($catid, $items)
		{
			global $mainframe;

			$db 	=& JFactory::getDBO();
			$user 	=& JFactory::getUser();
			$aid	= $user->get('aid', 0);

			$contentConfig	= &JComponentHelper::getParams( 'com_content' );
			$noauth			= !$contentConfig->get('shownoauth');

			jimport('joomla.utilities.date');
			$date = new JDate();
			$now = $date->toMySQL();

			$nullDate = $db->getNullDate();

			// query to determine article count
			$query = 'SELECT a.`title`,a.`introtext`,a.`fulltext`' .
				' FROM #__content AS a' .
				' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
				' WHERE a.state = 1 ' .
				($noauth ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid:'').
				' AND (a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' ) ' .
				' AND (a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )' .
				' AND cc.id=' . (int) $catid .
				' AND cc.published = 1' .
				' ORDER BY a.ordering';
			$db->setQuery($query, 0, $items);
			$rows = $db->loadObjectList();
			return $rows;
		}

		function getCat($catid)
		{
		  if(!$catid) return null;
			global $mainframe;

			$db 	=& JFactory::getDBO();

			// query to determine article count
			$query = 'SELECT title, image, description from #__categories where id='.$catid;
			$db->setQuery($query);
			$row = null;
			$row = $db->loadObject();
			return $row;
		}

		function getFile($name, $modPath, $tmplPath) {
			if (file_exists(JPATH_SITE.DS.$tmplPath.$name)) {
				return $tmplPath.$name;
			}
			return $modPath.$name;
		}		
	}
		
}